Index: /trunk/src/sys/arch/mips/mips/mips_machdep.c
===================================================================
--- /trunk/src/sys/arch/mips/mips/mips_machdep.c	(revision 151)
+++ /trunk/src/sys/arch/mips/mips/mips_machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: mips_machdep.c,v 1.205.4.1.2.1.2.45 2010/05/06 19:51:20 cliff Exp $	*/
+/*	mips_machdep.c,v 1.205.4.1.2.1.2.52 2011/04/29 08:26:29 matt Exp	*/
 
 /*
@@ -113,8 +113,7 @@
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 
-__KERNEL_RCSID(0, "$NetBSD: mips_machdep.c,v 1.205.4.1.2.1.2.45 2010/05/06 19:51:20 cliff Exp $");
-
-#define	__INTR_PRIVATE
-
+__KERNEL_RCSID(0, "mips_machdep.c,v 1.205.4.1.2.1.2.52 2011/04/29 08:26:29 matt Exp");
+
+#define __INTR_PRIVATE
 #include "opt_cputype.h"
 #include "opt_compat_netbsd32.h"
@@ -123,4 +122,5 @@
 #include <sys/systm.h>
 #include <sys/proc.h>
+#include <sys/intr.h>
 #include <sys/exec.h>
 #include <sys/reboot.h>
@@ -128,5 +128,4 @@
 #include <sys/lwp.h>
 #include <sys/sysctl.h>
-#include <sys/user.h>
 #include <sys/msgbuf.h>
 #include <sys/conf.h>
@@ -149,11 +148,13 @@
 #endif
 
-#include <uvm/uvm_extern.h>
+#include <uvm/uvm.h>
 
 #include <dev/cons.h>
 
+#include <mips/pcb.h>
 #include <mips/cache.h>
 #include <mips/frame.h>
 #include <mips/regnum.h>
+#include <mips/mips_opcode.h>
 
 #include <machine/cpu.h>
@@ -167,6 +168,18 @@
 #endif
 
-#if defined(MIPS32) || defined(MIPS64)
+#if (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
 #include <mips/mipsNN.h>		/* MIPS32/MIPS64 registers */
+
+#define	_MKINSN(a,b,c,d,e) ((uint32_t)(((a) << 26)|((b) << 21)|((c) << 16)|((d) << 11)|(e)))
+
+#ifdef _LP64
+#define	_LOAD_V0_L_PRIVATE_A0	_MKINSN(OP_LD, _R_A0, _R_V0, 0, offsetof(lwp_t, l_private))
+#define	_MTC0_V0_USERLOCAL	_MKINSN(OP_COP0, OP_DMT, _R_V0, MIPS_COP_0_TLB_CONTEXT, 2)
+#else
+#define	_LOAD_V0_L_PRIVATE_A0	_MKINSN(OP_LW, _R_A0, _R_V0, 0, offsetof(lwp_t, l_private))
+#define	_MTC0_V0_USERLOCAL	_MKINSN(OP_COP0, OP_MT, _R_V0, MIPS_COP_0_TLB_CONTEXT, 2)
+#endif
+#define	JR_RA			_MKINSN(OP_SPECIAL, _R_RA, 0, 0, OP_JR)
+
 #endif
 
@@ -176,4 +189,8 @@
 int	cpu_dump(void);
 
+#if (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
+static void mips_watchpoint_init(void);
+#endif
+
 #if defined(MIPS3_PLUS)
 uint32_t mips3_cp0_tlb_page_mask_probe(void);
@@ -184,17 +201,21 @@
 #endif
 
+/*
+ * safepri is a safe priority for sleepq to set for a spin-wait during
+ * autoconfiguration or after a panic which will allows interrupts to
+ * be delivered.  Used as an argument to splx().
+ */
+int safepri = IPL_SOFTSERIAL;
+
 #if defined(MIPS1)
 static void	mips1_vector_init(const struct splsw *);
 extern const struct locoresw mips1_locoresw;
+extern const mips_locore_jumpvec_t mips1_locore_vec;
 #endif
 
 #if defined(MIPS3)
-#if defined(MIPS3_5900)
-static void	r5900_vector_init(const struct splsw *);
-extern const struct locoresw mips5900_locoresw;
-#else
 static void	mips3_vector_init(const struct splsw *);
 extern const struct locoresw mips3_locoresw;
-#endif
+extern const mips_locore_jumpvec_t mips3_locore_vec;
 #endif
 
@@ -202,4 +223,11 @@
 static void	mips32_vector_init(const struct splsw *);
 extern const struct locoresw mips32_locoresw;
+extern const mips_locore_jumpvec_t mips32_locore_vec;
+#endif
+
+#if defined(MIPS32R2)
+static void	mips32r2_vector_init(const struct splsw *);
+extern const struct locoresw mips32r2_locoresw;
+extern const mips_locore_jumpvec_t mips32r2_locore_vec;
 #endif
 
@@ -207,4 +235,23 @@
 static void	mips64_vector_init(const struct splsw *);
 extern const struct locoresw mips64_locoresw;
+extern const mips_locore_jumpvec_t mips64_locore_vec;
+#endif
+
+#if defined(MIPS64R2)
+static void	mips64r2_vector_init(const struct splsw *);
+extern const struct locoresw mips64r2_locoresw;
+extern const mips_locore_jumpvec_t mips64r2_locore_vec;
+#endif
+
+#if defined(MIPS64_RMIXL)
+static void	mips64_rmixl_vector_init(const struct splsw *);
+extern const struct locoresw mips64_rmixl_locoresw;
+extern const mips_locore_jumpvec_t mips64_rmixl_locore_vec;
+#endif
+
+#if defined(MIPS64R2_RMIXL)
+static void	mips64r2_rmixl_vector_init(const struct splsw *);
+extern const struct locoresw mips64r2_rmixl_locoresw;
+extern const mips_locore_jumpvec_t mips64r2_rmixl_locore_vec;
 #endif
 
@@ -216,4 +263,5 @@
 
 struct locoresw mips_locoresw;
+//mips_locore_atomicvec_t mips_locore_atomicvec;
 
 extern const struct splsw std_splsw;
@@ -378,4 +426,5 @@
 	  CPU_MIPS_R4K_MMU | CPU_MIPS_DOUBLE_COUNT, 0, 0,
 						"Toshiba TX4927 CPU"	},
+
 	{ 0, MIPS_TX4900, -1, -1,		CPU_ARCH_MIPS3, 48,
 	  CPU_MIPS_R4K_MMU | CPU_MIPS_DOUBLE_COUNT, 0, 0,
@@ -402,11 +451,38 @@
 	  MIPS64_FLAGS,				0, 0, "20Kc"		},
 	{ MIPS_PRID_CID_MTI, MIPS_24K, -1, -1,	-1, 0,
-	  MIPS64_FLAGS | CPU_MIPS_DOUBLE_COUNT, 0, 0, "24K"		},
+	  MIPS32_FLAGS | CPU_MIPS_DOUBLE_COUNT,
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EBASE | MIPS_CP0FL_USERLOCAL | MIPS_CP0FL_HWRENA |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG2 |
+	  MIPS_CP0FL_CONFIG3 | MIPS_CP0FL_CONFIG7,
+	  0, "24K" },
 	{ MIPS_PRID_CID_MTI, MIPS_24KE, -1, -1,	-1, 0,
-	  MIPS64_FLAGS | CPU_MIPS_DOUBLE_COUNT, 0, 0, "24KE"		},
+	  MIPS32_FLAGS | CPU_MIPS_DOUBLE_COUNT,
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EBASE | MIPS_CP0FL_USERLOCAL | MIPS_CP0FL_HWRENA |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG2 |
+	  MIPS_CP0FL_CONFIG3 | MIPS_CP0FL_CONFIG7,
+	  0, "24KE" },
 	{ MIPS_PRID_CID_MTI, MIPS_34K, -1, -1,	-1, 0,
-	  MIPS64_FLAGS | CPU_MIPS_DOUBLE_COUNT, 0, 0, "34K"		},
+	  MIPS32_FLAGS | CPU_MIPS_DOUBLE_COUNT,
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EBASE | MIPS_CP0FL_USERLOCAL | MIPS_CP0FL_HWRENA |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG2 |
+	  MIPS_CP0FL_CONFIG3 | MIPS_CP0FL_CONFIG7,
+	  0, "34K" },
 	{ MIPS_PRID_CID_MTI, MIPS_74K, -1, -1,	-1, 0,
-	  MIPS64_FLAGS | CPU_MIPS_DOUBLE_COUNT, 0, 0, "74K"		},
+	  MIPS32_FLAGS | CPU_MIPS_DOUBLE_COUNT,
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EBASE | MIPS_CP0FL_USERLOCAL | MIPS_CP0FL_HWRENA |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG2 |
+	  MIPS_CP0FL_CONFIG3 | MIPS_CP0FL_CONFIG6 | MIPS_CP0FL_CONFIG7,
+	  0, "74K" },
+	{ MIPS_PRID_CID_MTI, MIPS_1004K, -1, -1,	-1, 0,
+	  MIPS32_FLAGS | CPU_MIPS_DOUBLE_COUNT,
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EBASE | MIPS_CP0FL_USERLOCAL | MIPS_CP0FL_HWRENA |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG2 |
+	  MIPS_CP0FL_CONFIG3 | MIPS_CP0FL_CONFIG6 | MIPS_CP0FL_CONFIG7,
+	  0, "1004K" },
 
 	{ MIPS_PRID_CID_ALCHEMY, MIPS_AU_REV1, -1, MIPS_AU1000, -1, 0,
@@ -444,6 +520,7 @@
 	  MIPS64_FLAGS | CPU_MIPS_D_CACHE_COHERENT | CPU_MIPS_NO_LLADDR |
 	  CPU_MIPS_I_D_CACHE_COHERENT | CPU_MIPS_HAVE_MxCR,
-	  MIPS_CP0FL_USE |MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
-	  MIPS_CP0FL_CONFIGn(0) | MIPS_CP0FL_CONFIGn(1) | MIPS_CP0FL_CONFIGn(7),
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG7,
 	  CIDFL_RMI_TYPE_XLR|MIPS_CIDFL_RMI_CPUS(8,4)|MIPS_CIDFL_RMI_L2(2MB),
 	  "XLR732B"		},
@@ -452,6 +529,7 @@
 	  MIPS64_FLAGS | CPU_MIPS_D_CACHE_COHERENT | CPU_MIPS_NO_LLADDR |
 	  CPU_MIPS_I_D_CACHE_COHERENT | CPU_MIPS_HAVE_MxCR,
-	  MIPS_CP0FL_USE |MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
-	  MIPS_CP0FL_CONFIGn(0) | MIPS_CP0FL_CONFIGn(1) | MIPS_CP0FL_CONFIGn(7),
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG7,
 	  CIDFL_RMI_TYPE_XLR|MIPS_CIDFL_RMI_CPUS(8,4)|MIPS_CIDFL_RMI_L2(2MB),
 	  "XLR732C"		},
@@ -460,6 +538,7 @@
 	  MIPS64_FLAGS | CPU_MIPS_D_CACHE_COHERENT | CPU_MIPS_NO_LLADDR |
 	  CPU_MIPS_I_D_CACHE_COHERENT | CPU_MIPS_HAVE_MxCR,
-	  MIPS_CP0FL_USE |MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
-	  MIPS_CP0FL_CONFIGn(0) | MIPS_CP0FL_CONFIGn(1) | MIPS_CP0FL_CONFIGn(7),
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG7,
 	  CIDFL_RMI_TYPE_XLS|MIPS_CIDFL_RMI_CPUS(4,4)|MIPS_CIDFL_RMI_L2(1MB),
 	  "XLS616"		},
@@ -468,6 +547,7 @@
 	  MIPS64_FLAGS | CPU_MIPS_D_CACHE_COHERENT | CPU_MIPS_NO_LLADDR |
 	  CPU_MIPS_I_D_CACHE_COHERENT | CPU_MIPS_HAVE_MxCR,
-	  MIPS_CP0FL_USE |MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
-	  MIPS_CP0FL_CONFIGn(0) | MIPS_CP0FL_CONFIGn(1) | MIPS_CP0FL_CONFIGn(7),
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG7,
 	  CIDFL_RMI_TYPE_XLS|MIPS_CIDFL_RMI_CPUS(4,4)|MIPS_CIDFL_RMI_L2(1MB),
 	  "XLS416"		},
@@ -476,6 +556,7 @@
 	  MIPS64_FLAGS | CPU_MIPS_D_CACHE_COHERENT | CPU_MIPS_NO_LLADDR |
 	  CPU_MIPS_I_D_CACHE_COHERENT | CPU_MIPS_HAVE_MxCR,
-	  MIPS_CP0FL_USE |MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
-	  MIPS_CP0FL_CONFIGn(0) | MIPS_CP0FL_CONFIGn(1) | MIPS_CP0FL_CONFIGn(7),
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG7,
 	  CIDFL_RMI_TYPE_XLS|MIPS_CIDFL_RMI_CPUS(2,4)|MIPS_CIDFL_RMI_L2(1MB),
 	  "XLS408"		},
@@ -484,6 +565,7 @@
 	  MIPS64_FLAGS | CPU_MIPS_D_CACHE_COHERENT | CPU_MIPS_NO_LLADDR |
 	  CPU_MIPS_I_D_CACHE_COHERENT | CPU_MIPS_HAVE_MxCR,
-	  MIPS_CP0FL_USE |MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
-	  MIPS_CP0FL_CONFIGn(0) | MIPS_CP0FL_CONFIGn(1) | MIPS_CP0FL_CONFIGn(7),
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG7,
 	  CIDFL_RMI_TYPE_XLS|MIPS_CIDFL_RMI_CPUS(2,4)|MIPS_CIDFL_RMI_L2(1MB),
 	  "XLS408lite"		},
@@ -492,6 +574,7 @@
 	  MIPS64_FLAGS | CPU_MIPS_D_CACHE_COHERENT | CPU_MIPS_NO_LLADDR |
 	  CPU_MIPS_I_D_CACHE_COHERENT | CPU_MIPS_HAVE_MxCR,
-	  MIPS_CP0FL_USE |MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
-	  MIPS_CP0FL_CONFIGn(0) | MIPS_CP0FL_CONFIGn(1) | MIPS_CP0FL_CONFIGn(7),
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG7,
 	  CIDFL_RMI_TYPE_XLS|MIPS_CIDFL_RMI_CPUS(1,4)|MIPS_CIDFL_RMI_L2(512KB),
 	  "XLS404lite"		},
@@ -500,6 +583,7 @@
 	  MIPS64_FLAGS | CPU_MIPS_D_CACHE_COHERENT | CPU_MIPS_NO_LLADDR |
 	  CPU_MIPS_I_D_CACHE_COHERENT | CPU_MIPS_HAVE_MxCR,
-	  MIPS_CP0FL_USE |MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
-	  MIPS_CP0FL_CONFIGn(0) | MIPS_CP0FL_CONFIGn(1) | MIPS_CP0FL_CONFIGn(7),
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG7,
 	  CIDFL_RMI_TYPE_XLS|MIPS_CIDFL_RMI_CPUS(2,4)|MIPS_CIDFL_RMI_L2(512KB),
 	  "XLS208"		},
@@ -508,6 +592,7 @@
 	  MIPS64_FLAGS | CPU_MIPS_D_CACHE_COHERENT | CPU_MIPS_NO_LLADDR |
 	  CPU_MIPS_I_D_CACHE_COHERENT | CPU_MIPS_HAVE_MxCR,
-	  MIPS_CP0FL_USE |MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
-	  MIPS_CP0FL_CONFIGn(0) | MIPS_CP0FL_CONFIGn(1) | MIPS_CP0FL_CONFIGn(7),
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG7,
 	  CIDFL_RMI_TYPE_XLS|MIPS_CIDFL_RMI_CPUS(1,4)|MIPS_CIDFL_RMI_L2(256KB),
 	  "XLS204"		},
@@ -516,6 +601,7 @@
 	  MIPS64_FLAGS | CPU_MIPS_D_CACHE_COHERENT | CPU_MIPS_NO_LLADDR |
 	  CPU_MIPS_I_D_CACHE_COHERENT | CPU_MIPS_HAVE_MxCR,
-	  MIPS_CP0FL_USE |MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
-	  MIPS_CP0FL_CONFIGn(0) | MIPS_CP0FL_CONFIGn(1) | MIPS_CP0FL_CONFIGn(7),
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG7,
 	  CIDFL_RMI_TYPE_XLS|MIPS_CIDFL_RMI_CPUS(2,4)|MIPS_CIDFL_RMI_L2(512KB),
 	  "XLS108"		},
@@ -524,6 +610,7 @@
 	  MIPS64_FLAGS | CPU_MIPS_D_CACHE_COHERENT | CPU_MIPS_NO_LLADDR |
 	  CPU_MIPS_I_D_CACHE_COHERENT | CPU_MIPS_HAVE_MxCR,
-	  MIPS_CP0FL_USE |MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
-	  MIPS_CP0FL_CONFIGn(0) | MIPS_CP0FL_CONFIGn(1) | MIPS_CP0FL_CONFIGn(7),
+	  MIPS_CP0FL_USE |
+	  MIPS_CP0FL_EIRR | MIPS_CP0FL_EIMR | MIPS_CP0FL_EBASE |
+	  MIPS_CP0FL_CONFIG | MIPS_CP0FL_CONFIG1 | MIPS_CP0FL_CONFIG7,
 	  CIDFL_RMI_TYPE_XLS|MIPS_CIDFL_RMI_CPUS(1,4)|MIPS_CIDFL_RMI_L2(256KB),
 	  "XLS104"		},
@@ -561,5 +648,5 @@
 	"RMI",
 };
-#define	ncidnames (sizeof(cidnames) / sizeof(cidnames[0]))
+#define	ncidnames __arraycount(cidnames)
 
 #if defined(MIPS1)
@@ -571,5 +658,4 @@
 mips1_vector_init(const struct splsw *splsw)
 {
-	extern const mips_locore_jumpvec_t mips1_locore_vec;
 	extern char mips1_utlb_miss[], mips1_utlb_miss_end[];
 	extern char mips1_exception[], mips1_exception_end[];
@@ -580,11 +666,8 @@
 	if (mips1_utlb_miss_end - mips1_utlb_miss > 0x80)
 		panic("startup: UTLB vector code too large");
-	memcpy((void *)MIPS_UTLB_MISS_EXC_VEC, mips1_utlb_miss,
-		mips1_utlb_miss_end - mips1_utlb_miss);
-
 	if (mips1_exception_end - mips1_exception > 0x80)
 		panic("startup: general exception vector code too large");
-	memcpy((void *)MIPS1_GEN_EXC_VEC, mips1_exception,
-		mips1_exception_end - mips1_exception);
+	memcpy((void *)MIPS_UTLB_MISS_EXC_VEC, mips1_utlb_miss,
+		mips1_exception_end - mips1_utlb_miss);
 
 	/*
@@ -605,5 +688,4 @@
 mips3_vector_init(const struct splsw *splsw)
 {
-	extern const mips_locore_jumpvec_t mips3_locore_vec;
 	/* r4000 exception handler address and end */
 	extern char mips3_exception[], mips3_exception_end[];
@@ -649,47 +731,8 @@
 #endif /* MIPS3 */
 
-#if defined(MIPS3_5900)	/* XXX */
-static void
-r5900_vector_init(const struct splsw *splsw)
-{
-	extern const mips_locore_jumpvec_t r5900_locore_vec;
-	extern char mips5900_exception[], mips5900_exception_end[];
-	extern char mips5900_tlb_miss[], mips5900_tlb_miss_end[];
-	size_t esz = mips5900_exception_end - mips5900_exception;
-	size_t tsz = mips5900_tlb_miss_end - mips5900_tlb_miss;
-
-	KDASSERT(tsz <= 0x80);
-	KDASSERT(esz <= 0x80);
-
-	if (tsz > 0x80)
-		panic("startup: UTLB vector code too large");
-	if (esz > 0x80)
-		panic("startup: General exception vector code too large");
-
-	memcpy((void *)MIPS_UTLB_MISS_EXC_VEC, mips5900_tlb_miss, tsz);
-	memcpy((void *)MIPS_R5900_COUNTER_EXC_VEC, mips5900_exception, esz);
-	memcpy((void *)MIPS_R5900_DEBUG_EXC_VEC, mips5900_exception, esz);
-	memcpy((void *)MIPS3_GEN_EXC_VEC, mips5900_exception, esz);
-	memcpy((void *)MIPS3_INTR_EXC_VEC, mips5900_exception, esz);
-
-	mips_locore_jumpvec = r5900_locore_vec;
-
-	mips_config_cache();
-
-	mips_icache_sync_all();
-	mips_dcache_wbinv_all();
-
-	/* Clear BEV in SR so we start handling our own exceptions */
-	mips_cp0_status_write(mips_cp0_status_read() & ~MIPS_SR_BEV);
-}
-#endif /* MIPS3_5900 */
-
 #if defined(MIPS32)
 static void
 mips32_vector_init(const struct splsw *splsw)
 {
-	/* MIPS32 locore function vector */
-	extern const mips_locore_jumpvec_t mips32_locore_vec;
-
 	/* r4000 exception handler address */
 	extern char mips32_exception[];
@@ -734,6 +777,75 @@
 	/* Clear BEV in SR so we start handling our own exceptions */
 	mips_cp0_status_write(mips_cp0_status_read() & ~MIPS_SR_BEV);
+
+	mips_watchpoint_init();
 }
 #endif /* MIPS32 */
+
+#if defined(MIPS32R2)
+static void
+mips32r2_vector_init(const struct splsw *splsw)
+{
+	/* r4000 exception handler address */
+	extern char mips32r2_exception[];
+
+	/* TLB miss handler addresses */
+	extern char mips32r2_tlb_miss[];
+
+	/* Cache error handler */
+	extern char mips32r2_cache[];
+
+	/* MIPS32 interrupt exception handler */
+	extern char mips32r2_intr[], mips32r2_intr_end[];
+
+	/*
+	 * Copy down exception vector code.
+	 */
+	if (mips32r2_cache - mips32r2_tlb_miss != 0x100)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "UTLB");
+	if (mips32r2_exception - mips32r2_cache != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "Cache error");
+	if (mips32r2_intr - mips32r2_exception != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "General exception");
+	if (mips32r2_intr_end - mips32r2_intr > 0x80)
+		panic("startup: %s vector code too large",
+		    "interrupt exception");
+
+	memcpy((void *)MIPS_UTLB_MISS_EXC_VEC, mips32r2_tlb_miss,
+	      mips32r2_intr_end - mips32r2_tlb_miss);
+
+	/*
+	 * If this CPU doesn't have a COP0 USERLOCAL register, at the end
+	 * of cpu_switch resume overwrite the instructions which update it.
+	 */
+	if (!(mips_options.mips_cpu->cpu_cp0flags & MIPS_CP0FL_USERLOCAL)) {
+		extern uint32_t mips32r2_cpu_switch_resume[];
+		for (uint32_t *insnp = mips32r2_cpu_switch_resume;; insnp++) {
+			KASSERT(insnp[0] != JR_RA);
+			if (insnp[0] == _LOAD_V0_L_PRIVATE_A0
+			    && insnp[1] == _MTC0_V0_USERLOCAL) {
+				insnp[0] = JR_RA;
+				insnp[1] = 0;		/* NOP */
+				break;
+			}
+		}
+	}
+
+	/*
+	 * Copy locore-function vector.
+	 */
+	mips_locore_jumpvec = mips32r2_locore_vec;
+
+	mips_icache_sync_all();
+	mips_dcache_wbinv_all();
+
+	/* Clear BEV in SR so we start handling our own exceptions */
+	mips_cp0_status_write(mips_cp0_status_read() & ~MIPS_SR_BEV);
+
+	mips_watchpoint_init();
+}
+#endif /* MIPS32R2 */
 
 #if defined(MIPS64)
@@ -741,7 +853,4 @@
 mips64_vector_init(const struct splsw *splsw)
 {
-	/* MIPS64 locore function vector */
-	extern const mips_locore_jumpvec_t mips64_locore_vec;
-
 	/* r4000 exception handler address */
 	extern char mips64_exception[];
@@ -790,6 +899,207 @@
 	/* Clear BEV in SR so we start handling our own exceptions */
 	mips_cp0_status_write(mips_cp0_status_read() & ~MIPS_SR_BEV);
+
+	mips_watchpoint_init();
 }
 #endif /* MIPS64 */
+
+#if defined(MIPS64R2)
+static void
+mips64r2_vector_init(const struct splsw *splsw)
+{
+	/* r4000 exception handler address */
+	extern char mips64r2_exception[];
+
+	/* TLB miss handler addresses */
+	extern char mips64r2_tlb_miss[];
+	extern char mips64r2_xtlb_miss[];
+
+	/* Cache error handler */
+	extern char mips64r2_cache[];
+
+	/* MIPS64 interrupt exception handler */
+	extern char mips64r2_intr[], mips64r2_intr_end[];
+
+	/*
+	 * Copy down exception vector code.
+	 */
+
+	if (mips64r2_xtlb_miss - mips64r2_tlb_miss != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "UTLB");
+	if (mips64r2_cache - mips64r2_xtlb_miss != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "XTLB");
+	if (mips64r2_exception - mips64r2_cache != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "Cache error");
+	if (mips64r2_intr - mips64r2_exception != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "General exception");
+	if (mips64r2_intr_end - mips64r2_intr > 0x80)
+		panic("startup: %s vector code too large",
+		    "interrupt exception");
+
+	memcpy((void *)MIPS_UTLB_MISS_EXC_VEC, mips64r2_tlb_miss,
+	      mips64r2_intr_end - mips64r2_tlb_miss);
+
+	/*
+	 * If this CPU doesn't have a COP0 USERLOCAL register, at the end
+	 * of cpu_switch resume overwrite the instructions which update it.
+	 */
+	if (!(mips_options.mips_cpu->cpu_cp0flags & MIPS_CP0FL_USERLOCAL)) {
+		extern uint32_t mips64r2_cpu_switch_resume[];
+		for (uint32_t *insnp = mips64r2_cpu_switch_resume;; insnp++) {
+			KASSERT(insnp[0] != JR_RA);
+			if (insnp[0] == _LOAD_V0_L_PRIVATE_A0
+			    && insnp[1] == _MTC0_V0_USERLOCAL) {
+				insnp[0] = JR_RA;
+				insnp[1] = 0;		/* NOP */
+				break;
+			}
+		}
+	}
+
+	/*
+	 * Copy locore-function vector.
+	 */
+	mips_locore_jumpvec = mips64r2_locore_vec;
+
+	mips_icache_sync_all();
+	mips_dcache_wbinv_all();
+
+	/* Clear BEV in SR so we start handling our own exceptions */
+	mips_cp0_status_write(mips_cp0_status_read() & ~MIPS_SR_BEV);
+
+	mips_watchpoint_init();
+}
+#endif /* MIPS64R2 */
+
+#if defined(MIPS64_RMIXL)
+static void
+mips64_rmixl_vector_init(const struct splsw *splsw)
+{
+	/* r4000 exception handler address */
+	extern char mips64_rmixl_exception[];
+
+	/* TLB miss handler addresses */
+	extern char mips64_rmixl_tlb_miss[];
+	extern char mips64_rmixl_xtlb_miss[];
+
+	/* Cache error handler */
+	extern char mips64_rmixl_cache[];
+
+	/* MIPS64 interrupt exception handler */
+	extern char mips64_rmixl_intr[], mips64_rmixl_intr_end[];
+
+	/*
+	 * Copy down exception vector code.
+	 */
+
+	if (mips64_rmixl_xtlb_miss - mips64_rmixl_tlb_miss != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "UTLB");
+	if (mips64_rmixl_cache - mips64_rmixl_xtlb_miss != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "XTLB");
+	if (mips64_rmixl_exception - mips64_rmixl_cache != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "Cache error");
+	if (mips64_rmixl_intr - mips64_rmixl_exception != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "General exception");
+	if (mips64_rmixl_intr_end - mips64_rmixl_intr > 0x80)
+		panic("startup: %s vector code too large",
+		    "interrupt exception");
+
+	memcpy((void *)MIPS_UTLB_MISS_EXC_VEC, mips64_rmixl_tlb_miss,
+	      mips64_rmixl_intr_end - mips64_rmixl_tlb_miss);
+
+	/*
+	 * Copy locore-function vector.
+	 */
+	mips_locore_jumpvec = mips64_rmixl_locore_vec;
+
+	mips_icache_sync_all();
+	mips_dcache_wbinv_all();
+
+	/* Clear BEV in SR so we start handling our own exceptions */
+	mips_cp0_status_write(mips_cp0_status_read() & ~MIPS_SR_BEV);
+
+	mips_watchpoint_init();
+}
+#endif /* MIPS64_RMIXL */
+
+#if defined(MIPS64R2_RMIXL)
+static void
+mips64r2_rmixl_vector_init(const struct splsw *splsw)
+{
+	/* r4000 exception handler address */
+	extern char mips64r2_rmixl_exception[];
+
+	/* TLB miss handler addresses */
+	extern char mips64r2_rmixl_tlb_miss[];
+	extern char mips64r2_rmixl_xtlb_miss[];
+
+	/* Cache error handler */
+	extern char mips64r2_rmixl_cache[];
+
+	/* MIPS64 interrupt exception handler */
+	extern char mips64r2_rmixl_intr[], mips64r2_rmixl_intr_end[];
+
+	/*
+	 * Copy down exception vector code.
+	 */
+
+	if (mips64r2_rmixl_xtlb_miss - mips64r2_rmixl_tlb_miss != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "UTLB");
+	if (mips64r2_rmixl_cache - mips64r2_rmixl_xtlb_miss != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "XTLB");
+	if (mips64r2_rmixl_exception - mips64r2_rmixl_cache != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "Cache error");
+	if (mips64r2_rmixl_intr - mips64r2_rmixl_exception != 0x80)
+		panic("startup: %s vector code not 128 bytes in length",
+		    "General exception");
+	if (mips64r2_rmixl_intr_end - mips64r2_rmixl_intr > 0x80)
+		panic("startup: %s vector code too large",
+		    "interrupt exception");
+
+	memcpy((void *)MIPS_UTLB_MISS_EXC_VEC, mips64r2_rmixl_tlb_miss,
+	      mips64r2_rmixl_intr_end - mips64r2_rmixl_tlb_miss);
+
+	/*
+	 * If this CPU doesn't have a COP0 USERLOCAL register, at the end
+	 * of cpu_switch resume overwrite the instructions which update it.
+	 */
+	if (!(mips_options.mips_cpu->cpu_cp0flags & MIPS_CP0FL_USERLOCAL)) {
+		extern uint32_t mips64r2_rmixl_cpu_switch_resume[];
+		for (uint32_t *insnp = mips64r2_rmixl_cpu_switch_resume;; insnp++) {
+			KASSERT(insnp[0] != JR_RA);
+			if (insnp[0] == _LOAD_V0_L_PRIVATE_A0
+			    && insnp[1] == _MTC0_V0_USERLOCAL) {
+				insnp[0] = JR_RA;
+				insnp[1] = 0;		/* NOP */
+				break;
+			}
+		}
+	}
+
+	/*
+	 * Copy locore-function vector.
+	 */
+	mips_locore_jumpvec = mips64r2_rmixl_locore_vec;
+
+	mips_icache_sync_all();
+	mips_dcache_wbinv_all();
+
+	/* Clear BEV in SR so we start handling our own exceptions */
+	mips_cp0_status_write(mips_cp0_status_read() & ~MIPS_SR_BEV);
+
+	mips_watchpoint_init();
+}
+#endif /* MIPS64R2_RMIXL */
 
 /*
@@ -814,5 +1124,5 @@
  */
 void
-mips_vector_init(const struct splsw *splsw)
+mips_vector_init(const struct splsw *splsw, bool multicpu_p)
 {
 	struct mips_options * const opts = &mips_options;
@@ -840,5 +1150,5 @@
 		panic("CPU type (0x%x) not supported", cpu_id);
 
-#if defined(MIPS32) || defined(MIPS64)
+#if (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
 	if (MIPS_PRID_CID(cpu_id) != 0) {
 		/* MIPS32/MIPS64, use coprocessor 0 config registers */
@@ -864,5 +1174,7 @@
 		switch (MIPSNN_GET(CFG_AR, cfg)) {
 		case MIPSNN_CFG_AR_REV1:
+			break;
 		case MIPSNN_CFG_AR_REV2:
+			opts->mips_cpu_arch += CPU_ARCH_MIPS32R2 - CPU_ARCH_MIPS32;
 			break;
 		default:
@@ -885,5 +1197,5 @@
 		}
 	}
-#endif /* defined(MIPS32) || defined(MIPS64) */
+#endif /* (MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0 */
 
 	if (opts->mips_cpu_arch < 1)
@@ -945,4 +1257,16 @@
 
 	/*
+	 * Default to RAS atomic ops since they are the lowest overhead.
+	 */
+#ifdef MULTIPROCESSOR
+	if (multicpu_p) {
+		/*
+		 * If we could have multiple CPUs active,
+		 * use the ll/sc variants.
+		 */
+		mips_locore_atomicvec = mips_llsc_locore_atomicvec;
+	}
+#endif
+	/*
 	 * Now initialize our ISA-dependent function vector.
 	 */
@@ -950,5 +1274,5 @@
 #if defined(MIPS1)
 	case CPU_ARCH_MIPS1:
-		mips1_tlb_invalidate_all();
+		(*mips1_locore_vec.ljv_tlb_invalidate_all)();
 		mips1_vector_init(splsw);
 		mips_locoresw = mips1_locoresw;
@@ -959,24 +1283,15 @@
 	case CPU_ARCH_MIPS4:
 		mips3_tlb_probe();
-#if defined(MIPS3_5900)	/* XXX */
-		mips3_cp0_pg_mask_write(MIPS3_PG_SIZE_4K);
-		mips3_cp0_wired_write(0);
-		mips5900_tlb_invalidate_all();
-		mips3_cp0_wired_write(pmap_tlb0_info.ti_wired);
-		r5900_vector_init(splsw);
-		mips_locoresw = mips5900_locoresw;
-#else /* MIPS3_5900 */
 #if defined(MIPS3_4100)
 		if (MIPS_PRID_IMPL(cpu_id) == MIPS_R4100)
-			mips3_cp0_pg_mask_write(MIPS4100_PG_SIZE_4K);
+			mips3_cp0_pg_mask_write(MIPS4100_PG_SIZE_TO_MASK(PAGE_SIZE));
 		else
 #endif
-		mips3_cp0_pg_mask_write(MIPS3_PG_SIZE_4K);
+		mips3_cp0_pg_mask_write(MIPS3_PG_SIZE_TO_MASK(PAGE_SIZE));
 		mips3_cp0_wired_write(0);
-		mips3_tlb_invalidate_all();
+		(*mips3_locore_vec.ljv_tlb_invalidate_all)();
 		mips3_cp0_wired_write(pmap_tlb0_info.ti_wired);
 		mips3_vector_init(splsw);
 		mips_locoresw = mips3_locoresw;
-#endif /* MIPS3_5900 */
 		break;
 #endif
@@ -984,7 +1299,7 @@
 	case CPU_ARCH_MIPS32:
 		mips3_tlb_probe();
-		mips3_cp0_pg_mask_write(MIPS3_PG_SIZE_4K);
+		mips3_cp0_pg_mask_write(MIPS3_PG_SIZE_TO_MASK(PAGE_SIZE));
 		mips3_cp0_wired_write(0);
-		mips32_tlb_invalidate_all();
+		(*mips32_locore_vec.ljv_tlb_invalidate_all)();
 		mips3_cp0_wired_write(pmap_tlb0_info.ti_wired);
 		mips32_vector_init(splsw);
@@ -992,13 +1307,68 @@
 		break;
 #endif
-#if defined(MIPS64)
+#if defined(MIPS32R2)
+	case CPU_ARCH_MIPS32R2:
+		mips3_tlb_probe();
+		mips3_cp0_pg_mask_write(MIPS3_PG_SIZE_TO_MASK(PAGE_SIZE));
+		mips3_cp0_wired_write(0);
+		(*mips32r2_locore_vec.ljv_tlb_invalidate_all)();
+		mips3_cp0_wired_write(pmap_tlb0_info.ti_wired);
+		mips32r2_vector_init(splsw);
+		mips_locoresw = mips32r2_locoresw;
+		break;
+#endif
+#if defined(MIPS64) || defined(MIPS64_RMIXL)
 	case CPU_ARCH_MIPS64: {
 		mips3_tlb_probe();
-		mips3_cp0_pg_mask_write(MIPS3_PG_SIZE_4K);
+		mips3_cp0_pg_mask_write(MIPS3_PG_SIZE_TO_MASK(PAGE_SIZE));
 		mips3_cp0_wired_write(0);
-		mips64_tlb_invalidate_all();
+#if defined(MIPS64)
+		(*mips64_locore_vec.ljv_tlb_invalidate_all)();
+#else
+		(*mips64_rmixl_locore_vec.ljv_tlb_invalidate_all)();
+#endif
 		mips3_cp0_wired_write(pmap_tlb0_info.ti_wired);
+#ifdef MIPS64_RMIXL
+		if (ct->cpu_cid == MIPS_PRID_CID_RMI) {
+			mips64_rmixl_vector_init(splsw);
+			mips_locoresw = mips64_rmixl_locoresw;
+			break;
+		}
+#endif
+#ifdef MIPS64
 		mips64_vector_init(splsw);
 		mips_locoresw = mips64_locoresw;
+#else
+		printf("cpu_arch 0x%x: not supported\n", opts->mips_cpu_arch);
+		cpu_reboot(RB_HALT, NULL);
+#endif
+		break;
+	}
+#endif
+#if defined(MIPS64R2) || defined(MIPS64R2_RMIXL)
+	case CPU_ARCH_MIPS64R2: {
+		mips3_tlb_probe();
+		mips3_cp0_pg_mask_write(MIPS3_PG_SIZE_TO_MASK(PAGE_SIZE));
+		mips3_cp0_wired_write(0);
+#ifdef MIPS64R2
+		(*mips64r2_locore_vec.ljv_tlb_invalidate_all)();
+#else
+		(*mips64r2_rmixl_locore_vec.ljv_tlb_invalidate_all)();
+#endif
+		mips3_cp0_wired_write(pmap_tlb0_info.ti_wired);
+#ifdef MIPS64R2_RMIXL
+		if (ct->cpu_cid == MIPS_PRID_CID_RMI) {
+			mips64r2_vector_init(splsw);
+			mips_locoresw = mips64r2_locoresw;
+			break;
+		}
+#endif
+#ifdef MIPS64R2
+		mips64r2_vector_init(splsw);
+		mips_locoresw = mips64r2_locoresw;
+#else
+		printf("cpu_arch 0x%x: not supported\n", opts->mips_cpu_arch);
+		cpu_reboot(RB_HALT, NULL);
+#endif
 		break;
 	}
@@ -1011,11 +1381,11 @@
 	/*
 	 * Now that the splsw and locoresw have been filled in, fixup the
-	 * jumps to their stubs to instead jump to the real routines.
-	 */
-	fixup_mips_cpu_switch_resume();
-	fixup_splcalls();
-
-/* XXX simonb: ugg, another ugly #ifdef check... */
-#if (defined(MIPS3) && !defined(MIPS3_5900)) || defined(MIPS32) || defined(MIPS64)
+	 * jumps to any stubs to actually jump to the real routines.
+	 */
+	extern uint32_t _ftext[];
+	extern uint32_t _etext[];
+	mips_fixup_stubs(_ftext, _etext);
+
+#if (MIPS3 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
 	/*
 	 * Install power-saving idle routines.
@@ -1024,5 +1394,5 @@
 	    !(opts->mips_cpu_flags & CPU_MIPS_NO_WAIT))
 		mips_locoresw.lsw_cpu_idle = mips_wait_idle;
-#endif /* (MIPS3 && !MIPS3_5900) || MIPS32 || MIPS64 */
+#endif /* (MIPS3 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0 */
 }
 
@@ -1030,6 +1400,5 @@
 mips_set_wbflush(void (*flush_fn)(void))
 {
-#undef wbflush
-	mips_locore_jumpvec.ljv_wbflush = flush_fn;
+	mips_locoresw.lsw_wbflush = flush_fn;
 	(*flush_fn)();
 }
@@ -1157,9 +1526,11 @@
 		break;
 #endif /* MIPS1 */
-#if defined(MIPS3) || defined(MIPS32) || defined(MIPS64)
+#if (MIPS3 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0
 	case CPU_ARCH_MIPS3:
 	case CPU_ARCH_MIPS4:
 	case CPU_ARCH_MIPS32:
-	case CPU_ARCH_MIPS64: {
+	case CPU_ARCH_MIPS32R2:
+	case CPU_ARCH_MIPS64:
+	case CPU_ARCH_MIPS64R2: {
 		const char *sufx = "KMGTPE";
 		uint32_t pg_mask;
@@ -1212,5 +1583,5 @@
 		break;
 	}
-#endif /* MIPS3 */
+#endif /* (MIPS3 + MIPS32 + MIPS32R2 + MIPS64 + MIPS64R2 + MIPS64_RMIXL + MIPS64R2_RMIXL) > 0 */
 	default:
 		panic("cpu_identify: impossible");
@@ -1228,10 +1599,12 @@
 setregs(struct lwp *l, struct exec_package *pack, u_long stack)
 {
-	struct trapframe *tf = l->l_md.md_utf;
+	struct trapframe * const tf = l->l_md.md_utf;
+	struct pcb * const pcb = lwp_getpcb(l);
+	struct proc * const p = l->l_proc;
 
 	memset(tf, 0, sizeof(struct trapframe));
-	tf->tf_regs[_R_SP] = (int)stack;
-	tf->tf_regs[_R_PC] = (int)pack->ep_entry & ~3;
-	tf->tf_regs[_R_T9] = (int)pack->ep_entry & ~3; /* abicall requirement */
+	tf->tf_regs[_R_SP] = (intptr_t)stack;
+	tf->tf_regs[_R_PC] = (intptr_t)pack->ep_entry & ~3;
+	tf->tf_regs[_R_T9] = (intptr_t)pack->ep_entry & ~3; /* abicall requirement */
 	tf->tf_regs[_R_SR] = PSL_USERSET;
 #if !defined(__mips_o32)
@@ -1239,8 +1612,24 @@
 	 * allow 64bit ops in userland for non-O32 ABIs
 	 */
-	if (l->l_proc->p_md.md_abi != _MIPS_BSD_API_O32)
+	if (p->p_md.md_abi == _MIPS_BSD_API_N32
+	    && (CPUISMIPS64 || CPUISMIPS64R2)) {
+		tf->tf_regs[_R_SR] |= MIPS_SR_PX;
+	} else if (p->p_md.md_abi != _MIPS_BSD_API_O32) {
 		tf->tf_regs[_R_SR] |= MIPS_SR_UX;
-	if (_MIPS_SIM_NEWABI_P(l->l_proc->p_md.md_abi))
+	}
+	if (_MIPS_SIM_NEWABI_P(p->p_md.md_abi))
 		tf->tf_regs[_R_SR] |= MIPS3_SR_FR;
+#endif
+#ifdef _LP64
+	/*
+	 * If we are using a 32-bit ABI on a 64-bit kernel, mark the process
+	 * that way.  If we aren't, clear it.
+	 */
+	if (p->p_md.md_abi == _MIPS_BSD_API_N32
+	    || p->p_md.md_abi == _MIPS_BSD_API_O32) {
+		p->p_flag |= PK_32;
+	} else {
+		p->p_flag &= ~PK_32;
+	}
 #endif
 	/*
